package nckd.poc602.plugin.form;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.HashSet;
import java.util.Set;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillShowParameter;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * @author xiaobing_wu
 * @date 2025-4-25
 */
public class RecBillFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
	@Override
	public void registerListener(EventObject e) {
		// TODO Auto-generated method stub
		super.registerListener(e);
	}
	
    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {

    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);

        String key = e.getProperty().getName();

        //核心单据号
        if("e_corebillno".equals(key) || "nckd_payname".equals(key)) {
            ChangeData[] changeValue = e.getChangeSet();
            int changeRow = changeValue[0].getRowIndex();
            String e_corebillno = (String) this.getModel().getValue("e_corebillno", changeRow);
            QFilter qf = new QFilter("billno",QCP.equals,e_corebillno);
            DynamicObject xsdd = BusinessDataServiceHelper.loadSingle("sm_salorder", "id,nckd_refbillfield,recplanentry.r_itemname,recplanentry.r_recadvanceamount,recplanentry.r_recamount", qf.toArray());
            if(xsdd != null) {
            	DynamicObject xsht = xsdd.getDynamicObject("nckd_refbillfield");
            	if(xsht != null) {
            		this.getView().getModel().setValue("nckd_refbillfield1", xsht, changeRow);
            	}
            	
            	Object nckd_paynameobj = this.getModel().getValue("nckd_payname", changeRow);
            	DynamicObject nckd_payname = null;
            	if(nckd_paynameobj != null) {
            		nckd_payname = (DynamicObject) nckd_paynameobj;
            		DynamicObjectCollection plans = xsdd.getDynamicObjectCollection("recplanentry");
            		for(DynamicObject plan : plans) {
            			DynamicObject r_itemname = plan.getDynamicObject("r_itemname");
            			BigDecimal r_recadvanceamount = plan.getBigDecimal("r_recadvanceamount");
            			BigDecimal r_recamount = plan.getBigDecimal("r_recamount");
            			if(r_itemname != null && r_itemname.getPkValue().equals(nckd_payname.getPkValue())) {
            				this.getView().getModel().setValue("e_receivableamt", r_recadvanceamount.subtract(r_recamount), changeRow);
            				break;
            			}
            		}
            	}
            }
        }
    }
    
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs afterDoOperationEventArgs) {
    	// TODO Auto-generated method stub
    	super.afterDoOperation(afterDoOperationEventArgs);
    	String opkey = afterDoOperationEventArgs.getOperateKey();
    	if("querysk".equals(opkey)) {
    		DynamicObject fkd = this.getModel().getDataEntity(true);
    		Set<Object> xshtids = new HashSet<>();
    		DynamicObjectCollection entrys = fkd.getDynamicObjectCollection("entry");
    		for(DynamicObject entryitem : entrys) {
    			DynamicObject xsht = entryitem.getDynamicObject("nckd_refbillfield");
    			if(xsht != null) {
    				xshtids.add(xsht.getPkValue());
    			}
    		}

    		if(!xshtids.isEmpty()) {
    			String skdentity = "cas_recbill";
    			Set<Object> skdids = new HashSet<>();
    			QFilter qf = new QFilter("entry.nckd_refbillfield1",QCP.in,xshtids);
    			DynamicObject[] skds = BusinessDataServiceHelper.load("cas_recbill", "id", qf.toArray());
    			for(DynamicObject skd : skds) {
    				skdids.add(skd.getPkValue());
    			}
    			if(skdids.size() == 1) {
        			BillShowParameter bsp = new BillShowParameter();
        			bsp.setFormId(skdentity);
        			bsp.setPkId(skdids.toArray()[0]);
        			bsp.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        			bsp.getOpenStyle().setTargetKey("tabap");
        			String pageId = this.generatePage4ListOp(this.getView(),skdentity, skdids.toArray()[0]);
        			bsp.setPageId(pageId);
        			this.getView().showForm(bsp);
    			}
    		}else {
    			this.getView().showErrorNotification("未找到关联的收款单");
    		}
    	}
    }
    
	private String generatePage4ListOp(IFormView currentView, String viewBillFormId, Object pkValue) {
		 return currentView.getPageId() + "_" + viewBillFormId + "_" + pkValue;
	}
}
